VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Speex"
   ClientHeight    =   3975
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9855
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3975
   ScaleWidth      =   9855
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Timer tmrPosition
      Enabled         =   0   'False
      Interval        =   250
      Left            =   720
      Top             =   4920
   End
   Begin VB.Frame fraFileInformation
      Caption         =   "File Information"
      Height          =   3735
      Left            =   5040
      TabIndex        =   10
      Top             =   120
      Width           =   4695
      Begin VB.ListBox lstFileInformation
         Height          =   3180
         Left            =   120
         TabIndex        =   11
         Top             =   360
         Width           =   4455
      End
   End
   Begin VB.Frame fraControls
      Caption         =   "Controls"
      Height          =   1335
      Left            =   120
      TabIndex        =   5
      Top             =   2520
      Width           =   4815
      Begin VB.HScrollBar hslPosition
         Enabled         =   0   'False
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   960
         Width           =   3015
      End
      Begin VB.CommandButton cmdStop
         Caption         =   "&Stop"
         Enabled         =   0   'False
         Height          =   495
         Left            =   3240
         TabIndex        =   8
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton cmdPause
         Caption         =   "Pa&use"
         Enabled         =   0   'False
         Height          =   495
         Left            =   1680
         TabIndex        =   7
         Top             =   360
         Width           =   1455
      End
      Begin VB.CommandButton cmdPlay
         Caption         =   "&Play"
         Height          =   495
         Left            =   120
         TabIndex        =   6
         Top             =   360
         Width           =   1455
      End
      Begin VB.Label lblPosition
         Alignment       =   2  'Zentriert
         Height          =   255
         Left            =   3240
         TabIndex        =   12
         Top             =   960
         Width           =   1455
      End
   End
   Begin VB.Frame fraOptions
      Caption         =   "Options"
      Height          =   1335
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   4815
      Begin VB.CheckBox chkFloatingPoint
         Caption         =   "Use &floating point output"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   360
         Width           =   4575
      End
      Begin VB.CheckBox chkLoop
         Caption         =   "&Loop"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   840
         Width           =   4575
      End
   End
   Begin VB.Frame fraFileName
      Caption         =   "File Name"
      Height          =   855
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4815
      Begin VB.CommandButton cmdBrowse
         Caption         =   ".&.."
         Height          =   255
         Left            =   4320
         TabIndex        =   2
         Top             =   360
         Width           =   375
      End
      Begin VB.TextBox txtFileName
         Height          =   285
         Left            =   120
         Locked          =   -1  'True
         TabIndex        =   1
         Top             =   360
         Width           =   4095
      End
   End
   Begin MSComDlg.CommonDialog cdlOpenFile
      Left            =   120
      Top             =   4920
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "Speex Files|*.spx"
      Flags           =   4100
      MaxFileSize     =   32767
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private blnScrolling As Boolean
Private blnUpdating As Boolean
Private lngFlags As Long
Private lngStreamHandle As Long

Private Sub chkLoop_Click()

    If chkLoop.value = vbChecked Then
        BASS_ChannelSetFlags lngStreamHandle, lngFlags + BASS_SAMPLE_LOOP
      Else
        BASS_ChannelSetFlags lngStreamHandle, lngFlags - BASS_SAMPLE_LOOP
    End If

End Sub

Private Sub cmdBrowse_Click()

    cdlOpenFile.ShowOpen
    txtFileName.Text = cdlOpenFile.FileName

End Sub

Private Sub cmdPause_Click()

    If cmdPause.Caption = "Pa&use" Then
        cmdPause.Caption = "Res&ume"
        BASS_ChannelPause lngStreamHandle
      Else
        cmdPause.Caption = "Pa&use"
        BASS_ChannelPlay lngStreamHandle, 0
    End If

End Sub

Private Sub cmdPlay_Click()

  Dim lngTagPointer As Long
  Dim strTagField As String
  Dim udtChannelInformation As BASS_CHANNELINFO

    BASS_StreamFree lngStreamHandle
    lstFileInformation.Clear

    lngFlags = 0

    If chkLoop.value = vbChecked Then
        lngFlags = BASS_SAMPLE_LOOP
    End If
    If chkFloatingPoint.value = vbChecked Then
        lngFlags = lngFlags + BASS_SAMPLE_FLOAT
    End If

    lngStreamHandle = BASS_SPX_StreamCreateFile(BASSFALSE, txtFileName.Text, 0, 0, lngFlags)

    If lngStreamHandle = 0 Then
        MsgBox "Error loading stream.", vbExclamation, "Error"
        Exit Sub
    End If

    DisableControls

    BASS_ChannelPlay lngStreamHandle, 1

    BASS_ChannelGetInfo lngStreamHandle, udtChannelInformation

    lstFileInformation.AddItem "----- [ Stream Properties ] -----"
    lstFileInformation.AddItem "samplerate = " & udtChannelInformation.freq
    lstFileInformation.AddItem "channels = " & udtChannelInformation.chans
    If udtChannelInformation.flags And BASS_SAMPLE_FLOAT Then
        lstFileInformation.AddItem "bitspersample = 32"
      Else
        lstFileInformation.AddItem "bitspersample = 16"
    End If
    If udtChannelInformation.ctype = BASS_CTYPE_STREAM_SPX Then
        lstFileInformation.AddItem "codec = Speex"
      Else
        lstFileInformation.AddItem "codec = Unknown"
    End If
    lstFileInformation.AddItem "bitrate = " & FileLen(txtFileName.Text) * 0.008 \ BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetLength(lngStreamHandle))

    lngTagPointer = BASS_StreamGetTags(lngStreamHandle, BASS_TAG_OGG)
    If Not lngTagPointer = 0 Then

        lstFileInformation.AddItem ""
        lstFileInformation.AddItem "----- [ Ogg Tag ] -----"
        Do
            strTagField = VBStrFromAnsiPtr(lngTagPointer)
            lngTagPointer = lngTagPointer + Len(strTagField) + 1
            If Not strTagField = vbNullString Then
                lstFileInformation.AddItem strTagField
            End If
        Loop While Not strTagField = vbNullString

    End If

    hslPosition.max = Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetLength(lngStreamHandle)))
    lblPosition.Caption = Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetPosition(lngStreamHandle))) & " / " & Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetLength(lngStreamHandle)))
    tmrPosition.Enabled = True

End Sub

Private Sub cmdStop_Click()

    tmrPosition.Enabled = False
    BASS_ChannelSetPosition lngStreamHandle, BASS_ChannelSeconds2Bytes(lngStreamHandle, 0)
    hslPosition.value = 0
    lblPosition.Caption = Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetPosition(lngStreamHandle))) & " / " & Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetLength(lngStreamHandle)))
    BASS_ChannelStop lngStreamHandle
    BASS_StreamFree lngStreamHandle
    EnableControls

End Sub

Private Sub DisableControls()

    fraFileName.Enabled = False
    txtFileName.Enabled = False
    chkFloatingPoint.Enabled = False
    cmdBrowse.Enabled = False
    cmdPlay.Enabled = False
    cmdPause.Enabled = True
    cmdStop.Enabled = True
    hslPosition.Enabled = True

End Sub

Private Sub EnableControls()

    fraFileName.Enabled = True
    txtFileName.Enabled = True
    chkFloatingPoint.Enabled = True
    cmdBrowse.Enabled = True
    cmdPlay.Enabled = True
    cmdPause.Caption = "Pa&use"
    cmdPause.Enabled = False
    cmdStop.Enabled = False
    hslPosition.Enabled = False

End Sub

Private Sub Form_Load()

    BASS_Init 1, 44100, 0, frmMain.hWnd, 0

End Sub

Private Sub Form_Unload(Cancel As Integer)

    BASS_Stop
    BASS_Free

    Set frmMain = Nothing

End Sub

Private Sub hslPosition_Change()

    If blnUpdating = True Then
        Exit Sub
    End If

    blnScrolling = False

    BASS_ChannelSetPosition lngStreamHandle, BASS_ChannelSeconds2Bytes(lngStreamHandle, hslPosition.value)

End Sub

Private Sub hslPosition_Scroll()

    blnScrolling = True

End Sub

Private Sub tmrPosition_Timer()

    lblPosition.Caption = Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetPosition(lngStreamHandle))) & " / " & Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetLength(lngStreamHandle)))

    blnUpdating = True

    If blnScrolling = False Then
        If Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetPosition(lngStreamHandle))) <= hslPosition.max Then
            hslPosition.value = Fix(BASS_ChannelBytes2Seconds(lngStreamHandle, BASS_ChannelGetPosition(lngStreamHandle)))
        End If
    End If

    If BASS_ChannelIsActive(lngStreamHandle) = 0 Then
        cmdStop_Click
    End If

    blnUpdating = False

End Sub



